/*
  TRONWARE VOL.85 Ͽ
  ̵ LAN 塼 ץץ

  AR饵 ץ (T-Engine/M32104)

  Copyright (C) 2004 Personal Media Corporation

  ưˡ

  IMS 夫

  lodspg @00100000  IPɥ쥹  ֥ͥåȥޥ  ݡֹ

  ˤäƵưޤ

  ʲΥߥɥ륦򤢤餫ɤƤƲ:
  - ARɥ饤
  - KASAGO for T-Engine/M32104 (TCP/IP ӥͥåȥɥ饤)

  Фȥ饤ȤȤδ֤Υץȥϼ̤Ǥ:

  - λ
    饤Ȣ: [0] (1 )
    Т饤: [0] (1 )

  - ž
    饤Ȣ: [1][饤ֹ][饤] (3 )
    Т饤: [] (160 * 饤 ϡե)
 */

#include <basic.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tk/tkernel.h>
#include <device/ar.h>
#include <btron/kasago.h>

/* AR */
#define PX           160  /* AR1饤Υԥ */
#define PY           144  /* ARΥ饤 */
#define COLOR          6  /* ARο礤 */
#define BRIGHTNESS    15  /* AR뤵*/
int dd;                   /* ץ󤷤ƤǥХǥץ */
short *ar_img;            /* AR餫黣Ƥ줿Ƭɥ쥹 */

/*
  AR餫
 */
void ar_take( void )
{
  int asiz, n;

  /* ARα */
  tk_srea_dev( dd, 0, (void*)&ar_img, sizeof(void*), &asiz );

  /* ΥǥѴ */
  for(n = 0; n < (PX * PY); n++) ar_img[n] = ka_htons( ar_img[n] );
}

/*
  AR˿礤뤵
 */
static void set_color( int x, int y )
{
  int asiz, k;

  /* 礤 */
  tk_swri_dev( dd, AR_COLOR, &x, sizeof(int), &asiz );

  /* 뤵 */
  tk_swri_dev( dd, AR_BRIGHTNESS, &y, sizeof(int), &asiz );

  /* 礤뤵ꤷϲ󤫻ƤʤȲꤷʤ */
  for( k = 0; k < 4; k++) ar_take();
}

/*
  ARŸȿ
 */
void set_hz( int x )
{
  int asiz;
  tk_swri_dev( dd, AR_HZ, &x, sizeof(int), &asiz );
}

/*
  
 */
int my_send( int fd, void *buf, int n )
{
  int r, k; char *p;

  for(p = buf, r = n; r > 0; r -= k, p += k) {
    k = ka_send( fd, (void*)p, r, 0 );
    if (k == 0) break;
    else if (k < 0) return -1;
  }
  return (n - r);
}

/*
  
 */
int my_recv( int fd, void *buf, int n )
{
  int r, k; char *p;

  for(p = buf, r = n; r > 0; r -= k, p += k) {
    k = ka_recv( fd, (void*)p, r, 0 );
    if (k == 0) break;
    else if (k < 0) return -1;
  }
  return (n - r);
}

/*
  Ф 1 åư
 */
void session( int cfd )
{
  int er, n, buf[3]; void *adr;

  for(;;) {
    /* 饤Ȥ׵ */
    n = my_recv( cfd, (void*)buf, sizeof(int) );
    if (n != sizeof(int)) return;

    /* ׵ν */
    switch (ka_ntohl( buf[0] )) {

    case 0 : /* λ */
      ar_take();
      adr = buf;
      n   = sizeof(int);
      break;

    case 1 : /* ž */
      n = my_recv( cfd, (void*)&buf[1], 2 * sizeof(int) );
      if (n != 2 * sizeof(int)) return;

      adr = &(ar_img[ka_ntohl( buf[1] ) * PX]);
      n   = (PX * sizeof(short)) * ka_ntohl( buf[2] );
      break;

    default :
      return;
    }

    /* 饤Ȥ */
    er = my_send( cfd, adr, n );
    if (er != n) return;
  }
}

/*
  
 */
void serv( char *ip, char *subnetmask, int port )
{
  int fd, er, cfd, clen;
  ttUserInterface ih;
  struct sockaddr_in saddr, caddr;

  /* ưåɽ */
  puts( "Server running" );

  /* ARǥХΥץ */
  dd = tk_opn_dev( "ara", TD_UPDATE );
  if (dd < 0) {
    puts( "AR driver not ready" );
    return;
  }
  set_hz( AR_50HZ );
  set_color( COLOR, BRIGHTNESS );

  /* ͥåȥ */
  memset( &saddr, 0, sizeof(saddr) );
  saddr.sin_family      = AF_INET;
  saddr.sin_port        = ka_htons( port );   /* ݡֹ */
  saddr.sin_addr.s_addr = ka_inet_addr( ip ); /* IPɥ쥹 */

  ih = ka_tfAddInterface( "Neta" );
  er = ka_tfOpenInterface( ih, saddr.sin_addr.s_addr,
			   ka_inet_addr( subnetmask ), 0, 1 );
  if (er < 0) {
    puts( "KASAGO not ready" );
    return;
  }

  fd = ka_socket( AF_INET, SOCK_STREAM, 0 ); /* åȤμ */
  if (fd < 0) {
    puts( "socket failed" );
    return;
  }

  er = ka_bind( fd, (struct sockaddr *)&saddr, sizeof(saddr) );
  if (er < 0) {
    puts( "bind failed" );
    return;
  }
  
  er = ka_listen( fd, 5 );
  if (er < 0) {
    puts( "listen failed" );
    return;
  }
  
  /* ФΥᥤ롼 */
  for(;;) {
    /* 饤Ȥ׵򥢥ץ */
    clen = sizeof(caddr);
    cfd = ka_accept( fd, (struct sockaddr *)&caddr, &clen );
    if (cfd < 0) continue;
    puts( inet_ntoa( caddr.sin_addr ) );

    /* 1åư */
    session( cfd );

    /*  */
    ka_tfClose( cfd );
    puts( "closed" );
  }
  /* ФϽλʤ */
}

/*
 ᥤ
 */
int main( int ac, char **av )
{
  if ( ac == 4 ) {
    serv( av[1], av[2], atoi(av[3]) ); /*  */
  } else {
    puts( "Usage: lodspg @00100000 IP-address subnet-mask port-No" );
  }
  return -1;
}

